var SPLASH = SPLASH || {};
	SPLASH.app = {
		elWidth: null,
		elHeight: null,
		slideId: 1,
		slideWrapper: $( '.slides-wrapper' ),
		slide: $( '.slide' ),
		slideTween: TweenMax,
		slideIsTweening: false,
		sliderForwardDir: true, 
		sliderAutoPlay: true,
		sliderAutoPlayDelay: 2,
		sliderTimeoutId: null,
		numberOfSlides:4,

		initPros: function(){
			//console.log( 'SPLASH init...' );
			this.elWidth = $( '#container' ).width();
			this.elHeight = $( '#container' ).height();
			this.setSlides();
		},

		setSlides: function(){
			var _this = this;

			// clone first and last slide
			this.slide.eq(0).clone().appendTo( this.slideWrapper );
			this.slide.eq(this.slide.length - 1).clone().prependTo( this.slideWrapper );

			var $slide = $( '.slide' );

			// position slides
			$.each($slide, function( i, obj ){
				$(obj).css({ 'left': _this.elWidth * i });
			});

			// set width of wrapper
			this.slideWrapper.width( this.elWidth * $slide.length );
			// set initial position of wrapper
			this.slidesWrapperPosition();
			this.eventControls();
		},

		slidesWrapperPosition: function(){
			this.slideWrapper.css({ left: -(this.elWidth * this.slideId) });
		},

		eventControls: function(){
			var _this = this;

			$( '#prevButton' ).click(function(){
				// make sure element not tweening before moving on
				if( !_this.slideIsTweening ) {

					_this.sliderForwardDir = false;
					_this.animateElementsOnExit();
					_this.slideId--;
				}
			});

			$( '#nextButton' ).click(function(){
				// make sure element not tweening before moving on
				if( !_this.slideIsTweening ) {

					_this.sliderForwardDir = true;
					_this.animateElementsOnExit();
					_this.slideId++;
				}
			});

			// initiate elements animation
			this.animateSlides();
			this.slideCTAandLogo();

			// make sure it cannot be navigate
			_this.slideIsTweening = true;
		},

		animateSlides: function(){
			var _this = this,
				$slide = _this.slide;

			this.slideTween = new TimelineMax({
				onComplete: function(){

					// console.log( $slide.length );

					// reset slide wrapper position
					if( _this.slideId < 1 ) {
						_this.slideId = $slide.length;
						_this.slidesWrapperPosition();
					}
					if( _this.slideId >= $slide.length+1) {
						
						SPLASH.app.sliderAutoPlay = false
					}
					if( _this.slideId > $slide.length ) {
						_this.slideId = 1;
						_this.slidesWrapperPosition();
					}
					
					// reset isTweening value
					_this.slideIsTweening = false;

					if( _this.sliderAutoPlay ) {
						_this.sliderTimeoutId = setTimeout(function(){
							// console.log( 'Autoplay...' );
							$( '#nextButton' ).click();
						}, _this.sliderAutoPlayDelay * 1000);
					}
				}
				
			});
			
			
			
			this.slideTween
				.to(this.slideWrapper, 1, { left: -(this.elWidth * this.slideId), ease: Sine.easeOut })
				.add( this.animateElementsOnEnter(), '-=0.9' )
				//console.log('animateIn');
			;

			// clear timeout
			clearTimeout( this.sliderTimeoutId );
			
			var maxAnimationTime = 30;
				TweenLite.delayedCall(maxAnimationTime, stopAnimation);
				
				function stopAnimation(){
					//console.log("coming_stp2");
					_this.sliderAutoPlay = false;
				}	
		},

		// on enter animations
		animateElementsOnEnter: function(){
			if ((typeof dynamicData != "undefined") && (typeof dynamicData['Dynamic_BG'] != "undefined") && (dynamicData['Dynamic_BG'].length >= 1)){
				var bg_color_0 = dynamicData['Dynamic_BG'][0]["bg_color_0"];
				var bg_color_1 = dynamicData['Dynamic_BG'][0]["bg_color_1"];
				var bg_color_2 = dynamicData['Dynamic_BG'][0]["bg_color_2"];
				var bg_color_3 = dynamicData['Dynamic_BG'][0]["bg_color_3"];
			}else{
				var bg_color_0 = "#a5a18f";
				var bg_color_1 = "#d0d1d3";
				var bg_color_2 = "#98cfd5";
				var bg_color_3 = "#d8f1dd";
			}
		
			var tl = new TimelineLite(),
				posX = this.elWidth,
				$slide = $( '.slide' ).eq( this.slideId );

				$(".slide-1").css("background-color", bg_color_3); //3
				$(".slide-2").css("background-color", bg_color_0); //0
				$(".slide-3").css("background-color", bg_color_1); //1
				$(".slide-4").css("background-color", bg_color_2); //2
			
			var slideURL = document.getElementsByClassName($slide[0]['className'].split(" ")[1]);
			var slideUL = document.getElementsByClassName("slides-wrapper")[0];
			
			$(".click_through").css('cursor','pointer').off().on("click",function(){ 
					console.log("click_through click");
					jvxAd.openClickThrough(slideURL[0].getAttribute('data-url'));
					jvxAd.recordAssetVariation("click", slideUL.getAttribute('data-val'));
					jvxAd.recordEventByName(slideURL[0].getAttribute('data-value')+"_Interaction", 1);
				});
			jvxAd.recordEventByName(slideURL[0].getAttribute('data-value')+"_NonInteraction", 0);
			// set from direction
			if( !this.sliderForwardDir ) {
				posX = -this.elWidth;
				$(".slide-1").css("background-color", bg_color_1); //1
				$(".slide-2").css("background-color", bg_color_2); //2
				$(".slide-3").css("background-color", bg_color_3); //3
				$(".slide-4").css("background-color", bg_color_0); //0
			}

			//tl.staggerFromTo(this.animateElementsArray(), 1, { x: posX }, { x: 0, ease: Sine.easeInOut }, delay =+0.25);

			tl
			.fromTo($slide.find( 'h2' ), 1, { x: posX }, { x: 0, ease: Sine.easeOut})
			.fromTo($slide.find( '.circle' ), 1, { x: posX }, { x: 0, ease: Sine.easeOut}, delay =+0.125)
			.to('.circle', 1, { scale: 1.6 }, delay =+0.125)
			.fromTo($slide.find( '.product' ), 1, { x: posX }, { x: 0, ease: Sine.easeOut}, delay =+0.25)
			.fromTo($slide.find( '.name' ), 1, { x: posX }, { x: 0, ease: Sine.easeOut}, delay =+0.5)
			.fromTo($slide.find( '.price' ), 1, { x: posX }, { x: 0, ease: Sine.easeOut}, delay =+0.75)
			;
			
					
			return tl;
			
			
		},

		// on exit animations
		animateElementsOnExit: function(){

			//console.log('animateOut');
			var _this = this,
				tl = new TimelineLite({
					//onComplete: function(){
					//	_this.animateSlides();
					//},

					onStart: function(){
						var $slide = _this.slide;

						// reset the elements for specific slider which orginally cloned
						// to make sure it doesn't disappear at the end when slides-wrapper reset position

						// console.log( _this.slideId );

						if( _this.slideId < 1 ) {
							// last slider
							TweenMax.set(_this.animateElementsArray($slide.length), { x: 0 });
						}

						if( _this.slideId > $slide.length ) {
							// first slider
							TweenMax.set(_this.animateElementsArray(1), { x: 0 });
						}
					}
				}),
				posX = this.elWidth;

			// set from direction
			if( this.sliderForwardDir ) {
				posX = -this.elWidth;
			}
			
			tl.staggerTo(this.animateElementsArray(), 1, { x: posX, ease: Sine.easeIn }, delay =+0.25);
			tl.add( function(){ _this.animateSlides(); }, delay -=0.75);

			// make sure it cannot be navigate
			_this.slideIsTweening = true;
		},

		animateElementsArray: function( id ){
			var thisId;

			if( id ) {
				thisId = id;
			}
			else {
				thisId = this.slideId;
			}

			var $slide = $( '.slide' ).eq( thisId ),
				elems = [ $slide.find( 'h2' ), $slide.find( '.product' ), $slide.find( '.name' ), $slide.find( '.price' ) ];

			return elems;
		},

		slideCTAandLogo: function(){
			var tl = new TimelineLite();
				tl.from('.head1', 0.5, { x: 250 }, delay =+0.5)
				.from('.logo, #cta', 0.5, { y: 250 }, delay =+0.5)
				
		}
	};

	SPLASH.utils = {
		autoSizeText: function(){
			var el, elements, _i, _len, _results;
			var stopCount = 0;
			elements = $( '.autoresize' );
			// console.log( elements );

			if (elements.length < 0) {
				return;
			}

			_results = [];
			for (_i = 0, _len = elements.length; _i < _len; _i++) {
				el = elements[_i];
				_results.push((function(el) {
					var resizeText, _results1;

					resizeText = function() {
						stopCount++;
						var elNewFontSize;
						
						elNewFontSize = (parseInt($(el).css('font-size').slice(0, -2)) - 1) + 'px';
				
						return $(el).css('font-size', elNewFontSize);
					};

					_results1 = [];
					while ((el.scrollHeight > el.offsetHeight) && (stopCount<100)) {
						_results1.push(resizeText());

					} 
				
					
					
					return _results1;
				})(el));

		
			}
			//console.log(_results)
			

			//return _results;
		},
		positionTop1:function() {
			var elements = $( '.name' );
           for(i=0;i<elements.length;i++){			   
				var el1 = $(".name")[i].scrollHeight;
				var el1p = $(".price")[i].scrollHeight;
				var totalHeight = el1 + el1p;
				var setHeight = 390 - totalHeight;
				$(".name")[i].style.top = setHeight/2 + "px";
			}
        },
		positionPrice:function() {

			
			elements = $( '.price' );
			if (elements.length < 0) {
				return;
			}
			//_results = [];
			for (_i = 0; _i < elements.length; _i++) {
				el = elements[_i];
			
					//check for the previous one font size.
					var fs = 	$(el).prev().css( "font-size" );
					var t = $(el).prev().position().top
					var h = $(el).prev().height();
					//matching the font size to the product
					//$(el).css('font-size',fs);
					//position the price 
					$(el).css('top',t+h+2 )
					
			

			}
		}
		// positionCta:function() {
			// var ctaWidth = $("#cta").innerWidth();
				// var containerWidth = parseInt($("#container").css("width"));
				// document.getElementById("cta").style.marginLeft = (containerWidth - ctaWidth)/2 +"px";
		// }


	};

	